package ui;

import java.awt.event.MouseEvent;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.util.Arrays;
import java.util.Calendar;
import java.util.TimeZone;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.apache.commons.io.*;
import org.apache.commons.net.ntp.NTPUDPClient;
import org.apache.commons.net.ntp.TimeInfo;
import java.awt.image.BufferedImage;
import java.net.URL;
import java.net.URLConnection;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Tony
 */
public class MainFrame extends javax.swing.JFrame {

    /**
     * Creates new form MainFrame
     */
    ui.MainFrame mFrame;
    BufferedImage img;
    String name;
    String subject;
//    public static final String TIME_SERVER = "time-a.nist.gov";
    public static final String TIME_SERVER = "time-a.nist.gov";
    public MainFrame(String nameTemp,String subjectTemp) {
        initComponents();
        this.setLocationRelativeTo(null);
        mFrame = this;
        name = nameTemp;
        subject = subjectTemp;
        jLabel1.setText("Hello, "+name);
        jLabel2.setText("Subject: "+subject);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton3 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        jMenuItem1.setText("Delete");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("res/Bundle"); // NOI18N
        setTitle(bundle.getString("appTitle")); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jLabel1.setText("Hello, {Name}");

        jLabel2.setText("Subject: Mathematics");

        jButton1.setText("New...");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel3.setText("Lecture list:");

        jButton2.setText("Delete");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTable1.setFont(new java.awt.Font("Lucida Grande", 0, 13)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cohort", "Subject", "Venue", "Time", "Date"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setComponentPopupMenu(jPopupMenu1);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(jTable1);

        jButton3.setText("Take Attendance");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton5.setText("Refresh");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2)
                            .addComponent(jLabel3))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton3)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(jButton3)
                    .addComponent(jButton5))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        int[] selectedRows = jTable1.getSelectedRows();
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        String[][] lectureInfoArray = new String[selectedRows.length][model.getColumnCount()];
        for (int i = selectedRows.length - 1; i >= 0; i-- ){
            String[] temp = new String[model.getColumnCount()];
            for (int j=0; j<model.getColumnCount();j++){
                temp[j] = (String)((DefaultTableModel)jTable1.getModel()).getValueAt(selectedRows[i], j);
            }
            lectureInfoArray[selectedRows.length - 1 - i] = temp;
//            System.out.println(Arrays.toString(temp));
            model.removeRow(selectedRows[i]);
        }
        jButton3.setEnabled(false);
        new DeleteLectureThread(lectureInfoArray).start();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        NewLectureFrame newLecture = new NewLectureFrame(mFrame);
        newLecture.setVisible(true);
        mFrame.setFocusableWindowState(false);
        mFrame.setEnabled(false);
    }//GEN-LAST:event_jButton1ActionPerformed


    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
//        // TODO add your handling code here:
        if (jTable1.getSelectedRowCount() == 1){
            int hashCode;
            DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
            String[] lectureInfoArray = new String[model.getColumnCount()];
            for (int i=0; i<lectureInfoArray.length; i++){
                lectureInfoArray[i] = (String)((DefaultTableModel)jTable1.getModel()).getValueAt(jTable1.getSelectedRow(), i);
            }
            new UploadLectureTimeThread(toFileName(lectureInfoArray),mFrame).start();
            System.out.println("Original: " + toFileName(lectureInfoArray));
//            if("1EC1_1475413200".equals(toFileName(lectureInfoArray))){
//                System.err.print("True");
//            }
            hashCode = Arrays.hashCode(toFileName(lectureInfoArray).getBytes());
//            System.out.println(Arrays.hashCode("1EC1_1475413200".getBytes()));
            System.out.println("HashCode: " + hashCode);
            img = method.QrGenerator.generateImage(Integer.toString(hashCode));
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    public long checkTime() throws IOException{
//        NTPUDPClient timeClient = new NTPUDPClient();
//        System.out.println("Requesting Internet time");
//        InetAddress inetAddress = InetAddress.getByName(TIME_SERVER);
//        System.out.println(inetAddress);
//        System.out.println(timeClient);
//        TimeInfo timeInfo = timeClient.getTime(inetAddress);
//        System.out.println("Internet time get");
        URL url = new URL("http://www.bjtime.cn");
          //生成连接对象
          URLConnection uc = url.openConnection();
          //发出连接
          uc.connect();
          long time = uc.getDate();
          System.out.println("long time:"+time);
//        return timeInfo.getReturnTime();
        return time;
    }
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // TODO add your handling code here:
        new FetchLectureThread().start();
    }//GEN-LAST:event_formWindowOpened

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
        new FetchLectureThread().start();
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
        // TODO add your handling code here:
        if(evt.getClickCount() == 2){
            if (jTable1.getSelectedRowCount() == 1){
                DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
                String [] selectedContent = new String [jTable1.getColumnCount()];
                for (int i = 0; i < jTable1.getColumnCount(); i++){
                    selectedContent[i] = (String) model.getValueAt(jTable1.getSelectedRow(),i);
                }
                String lectureName = toFileName(selectedContent);
//                mFrame.setFocusableWindowState(false);
                CheckAttendanceFrame checkAttendance = new CheckAttendanceFrame(mFrame,lectureName,parseFileName(lectureName));            
//                mFrame.setEnabled(false);
            }
        }
    }//GEN-LAST:event_jTable1MouseClicked

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem1ActionPerformed
    
    class FetchLectureThread extends Thread{
        @Override
        public void run(){
            mFrame.setTitle("Fetching lecture list...");
            mFrame.setEnabled(false);
            try {
                DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
                int count = model.getRowCount();
                for(int i = 0; i < count; i++){
                    model.removeRow(0);
                }
                String[][] data = new method.Http().connection("type=select&table="+subject.toLowerCase()+"&variables=id");
                if (data!=null){
                    for (int i=0;i<data.length;i++){
                        String[] parsedFileNameArray = parseFileName(data[i][0]);
                        if (subject.toLowerCase().equals("admin")){
                            model.addRow(parseFileName(data[i][0]));
                        }else{
                            if (parsedFileNameArray[1].equals(subject)){
                                model.addRow(parseFileName(data[i][0]));
                            }
                        }
//                        System.out.println(data[i][0]);
                    }
                }
//                FTPClient ftp = new FTPClient();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                FTPFile[] f = ftp.listFiles("/smartattendance/lectures");
//                ftp.logout();
//                ftp.disconnect();
//                f = Arrays.copyOfRange(f, 2, f.length);
//                DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
//                int count = model.getRowCount();
//                for(int i = 0; i < count; i++){
//                    model.removeRow(0);
//                }
//                for (FTPFile f1 : f) {
////                    System.out.println("File: " + f1.getName());
//                    model.addRow(parseFileName(f1.getName()));
//                }
                mFrame.setTitle(java.util.ResourceBundle.getBundle("res/Bundle").getString("appTitle"));
                mFrame.setEnabled(true);
                jButton3.setEnabled(true);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(mFrame, "Network error.", "Error", JOptionPane.ERROR_MESSAGE);
                mFrame.setEnabled(true);
                jButton3.setEnabled(true);
            }
        }
    }
    
        
    class UploadLectureTimeThread extends Thread{
        String fileName;
        public UploadLectureTimeThread(String fileName1,MainFrame mFrame){
            fileName = fileName1;
        }
        public void run(){
            mFrame.setFocusable(false);
            mFrame.setEnabled(false);
            mFrame.setTitle("Uploading lecture time...");
            Calendar c = Calendar.getInstance();
            try {
                c.setTimeInMillis(checkTime());
            } catch (IOException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            }
            String currentTime = Long.toString(c.getTimeInMillis() / 1000);
            try {
                String [][]data = new method.Http().connection(
                        "type=select&table="+subject.toLowerCase()+"&variables=time&filter=id=\'"+fileName+"\'");
                String timeString;
                if (data[0][0].equals("None")){
                    timeString = currentTime;
                }else{
                    timeString = data[0][0] + ";"+currentTime;
                }
                new method.Http().connection("type=update&table="+subject.toLowerCase()+"&variables=time = \'" + timeString +"\'&filter=id = \'"+fileName+"\'");
//                FTPClient ftp = new FTPClient();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                InputStream ifs = ftp.retrieveFileStream("/smartattendance/lectures/"+fileName);
//                String d = IOUtils.toString(ifs, "UTF-8");
//                ifs.close();
//                ftp.logout();
//                ftp.disconnect();
//                String[] l = d.split("\n");
////                System.out.println(l[0]);
////                System.out.println(l[0].length());
////                System.out.println((int) l[0].charAt(l[0].length()-1));
////                System.out.println(l[0].equals("null"));
//                if(l[0].charAt(l[0].length() - 1) == '\r'){
//                    l[0] = l[0].substring(0,l[0].length()-1);
//                }
//                if (l[0].equals("null")){
//                    l[0] = currentTime;
////                    System.out.println("hahaha");
//                }else{
//                    l[0] += "," + currentTime;
//                }
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                OutputStream sfs = ftp.storeFileStream("/smartattendance/lectures/" + fileName);
//                for (int i =0; i< l.length; i++){
//                    sfs.write((l[i] + "\n").getBytes());
//                }
////                System.out.println(Arrays.toString(l));
//                sfs.close();
//                ftp.logout();
//                ftp.disconnect();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                InputStream ifs1 = ftp.retrieveFileStream("/smartattendance/lectures/"+fileName);
//                String checkContent = IOUtils.toString(ifs1, "UTF-8");
//                String firstLine = checkContent.split("\n")[0];
//                if (firstLine.charAt(firstLine.length()-1) == '\r'){
//                    firstLine = firstLine.substring(0,firstLine.length()-1);
//                
//                if (firstLine.equals("null")){
//                    System.out.println("lecture time upload failed");
//                    mFrame.setTitle(java.util.ResourceBundle.getBundle("res/Bundle").getString("appTitle"));
//                    mFrame.setFocusable(true);
//                    mFrame.setEnabled(true);
//                }else{
                System.out.println("lecture time upload successful");
                mFrame.setTitle(java.util.ResourceBundle.getBundle("res/Bundle").getString("appTitle"));
                QrDisplay qrDisplay = new QrDisplay(mFrame, img);
                qrDisplay.setVisible(true);
                mFrame.setFocusable(false);
                mFrame.setEnabled(false);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(mFrame, "Network error.", "Error", JOptionPane.ERROR_MESSAGE);
                System.err.println("IOError");
            }
        }
    }
    
    class UploadLectureThread extends Thread{
        String f;
        String des;
        UploadLectureThread(String filename, String description){
            f = filename;
            des = description;
        }
        @Override
        public void run(){
            mFrame.setTitle("Updating lecture info...");
            mFrame.setEnabled(false);
            try {
                System.out.println(new method.Http().connection("type=insert_row&table="+subject.toLowerCase()+"&values=\'"+f+"\'"));
//                FTPClient ftp = new FTPClient();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                InputStream ifs = ftp.retrieveFileStream("/smartattendance/student_data");
//                String d = IOUtils.toString(ifs, "UTF-8");
//                String[] l = d.split("\n");
//                String[] userlist = new String[l.length];
//                for(int i = 0; i < l.length; i++){
//                    userlist[i] = l[i].substring(0, l[i].indexOf(','));
////                    System.out.println(userlist[i]);
//                }
//                ifs.close();
//                ftp.logout();
//                ftp.disconnect();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                OutputStream sfs = ftp.storeFileStream("/smartattendance/lectures/" + f);
//                sfs.write((des + "\n").getBytes());
//                for(int i = 0; i < userlist.length; i++){
//                    sfs.write((userlist[i] + "\n").getBytes());
//                }
//                sfs.close();
//                ftp.logout();
//                ftp.disconnect();
                mFrame.setTitle(java.util.ResourceBundle.getBundle("res/Bundle").getString("appTitle"));
                mFrame.setEnabled(true);
                new FetchLectureThread().start();
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(mFrame, "Network error.", "Error", JOptionPane.ERROR_MESSAGE);
                mFrame.setEnabled(true);
            }
        }
    }
    
    class DeleteLectureThread extends Thread{
        String[][] lectureInfoArray;
        DeleteLectureThread(String[][] temp){
            lectureInfoArray = temp;
        }
        @Override
        public void run(){
            mFrame.setTitle("Updating lecture info...");
            mFrame.setEnabled(false);
            try {
                for (int i=0;i<lectureInfoArray.length;i++){
                    new method.Http().connection("type=delete_row&table="+subject+"&filter=id=\'"+toFileName(lectureInfoArray[i])+"\'");
                }
//                FTPClient ftp = new FTPClient();
//                ftp.connect("niqiukun.web.fc2.com");
//                ftp.login("niqiukun", "Zaq12wsX");
//                for(int i = 0; i < lectureInfoArray.length; i++){
//                    ftp.deleteFile("/smartattendance/lectures/" + toFileName(lectureInfoArray[i]));
////                    InputStream ifs = ftp.retrieveFileStream("/smartattendance/lectures/" + toFileName(lectureInfoArray[i]));
////                    String d = IOUtils.toString(ifs, "UTF-8");
////                    System.out.println(d);
//                }
//                ftp.logout();
//                ftp.disconnect();
                mFrame.setTitle(java.util.ResourceBundle.getBundle("res/Bundle").getString("appTitle"));
                mFrame.setEnabled(true);
                new FetchLectureThread().start();
            } catch (IOException ex) {
                mFrame.setEnabled(true);
            }
        }
    }
    
    private String[] parseFileName(String filename){
        String subject = null;
        String cohort = null;
        String venue = null;
        String date = null;
        String time = null;
        switch(filename.charAt(0)){
            case '1':
                cohort = "SH1";
                break;
            case '2':
                cohort = "SH2";
                break;
        }
        switch(filename.substring(1, 3)){
            case "MA":
                subject = "Mathmatics";
                break;
            case "CM":
                subject = "Chemistry";
                break;
            case "PH":
                subject = "Physics";
                break;
            case "BI":
                subject = "Biology";
                break;
            case "EC":
                subject = "Economics";
                break;
        }
        switch(filename.charAt(3)){
            case '1':
                venue = "LT1";
                break;
            case '2':
                venue = "LT2";
                break;
            case '3':
                venue = "LT3";
                break;
            case '4':
                venue = "LT4";
                break;
            case '5':
                venue = "LT5";
                break;
        }
        Calendar c = Calendar.getInstance();
        c.setTimeZone(TimeZone.getTimeZone("GMT"));
        c.setTimeInMillis(1000 * Long.parseLong(filename.substring(filename.indexOf('_') + 1)));
//        System.out.println(c.getTimeInMillis());
        date = zfill(Integer.toString(c.get(Calendar.DAY_OF_MONTH))) + "/" +
               zfill(Integer.toString(c.get(Calendar.MONTH) + 1)) + "/" +
               Integer.toString(c.get(Calendar.YEAR)).substring(2);
        time = zfill(Integer.toString(c.get(Calendar.HOUR_OF_DAY))) + zfill(Integer.toString(c.get(Calendar.MINUTE)));
        String[] array = {cohort, subject, venue, time, date};
        return array;
    }
    
    private String toFileName(String[] array){
//        System.out.println(Arrays.toString(array));
        String subject = array[1];
        String cohort = array[0];
        String venue = array[2];
        String date = array[4];
        String time = array[3];
        String result = "";
        result += cohort.charAt(cohort.length() - 1);
        switch(subject){
            case "Mathmatics":
                result += "MA";
                break;
            case "Physics":
                result += "PH";
                break;
            case "Chemistry":
                result += "CM";
                break;
            case "Biology":
                result += "BI";
                break;
            case "Economics":
                result += "EC";
                break;
        }
        result += venue.charAt(venue.length() - 1);
        Calendar c = Calendar.getInstance();
        c.setTimeZone(TimeZone.getTimeZone("GMT"));
        c.set(Integer.parseInt(date.substring(6)) + 2000,
              Integer.parseInt(date.substring(3, 5)) - 1,
              Integer.parseInt(date.substring(0, 2)),
              Integer.parseInt(time.substring(0, 2)),
              Integer.parseInt(time.substring(2)),
              0);
        result += "_";
        result += Long.toString(c.getTimeInMillis() / 1000);
//        System.out.println(result);
        return result;
    }
    
    public String zfill(String number){
        switch(number.length()){
            case 1:
                return "0" + number;
            case 2:
                return number;
        }
        return null;
    }
    
    public void addLecture(String[] lectureInfoArray){
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        model.addRow(lectureInfoArray);
        new UploadLectureThread(toFileName(lectureInfoArray), "null").start();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables

}
